package com.domemusictechnologies.fifthdimension;


import voltage.controllers.*;
import voltage.core.*;
import voltage.core.Jack.JackType;
import voltage.sources.*;
import voltage.utility.*;
import voltage.processors.*;
import voltage.effects.*;
import java.awt.*;

//[user-imports]   Add your own imports here
//[/user-imports]


public class FifthDimension extends VoltageModule
//[user-inheritance]
//[/user-inheritance]
{

public FifthDimension( long moduleID, VoltageObjects voltageObjects )
{
   super( moduleID, voltageObjects, "Fifth Dimension Phaser Factory", ModuleType.ModuleType_Filters, 2.0 );

   InitializeControls();


   canBeBypassed = true;
   SetSkin( "749aaca65f00408f9ff6c102105b246a" );
}

void InitializeControls()
{

   inputAudio = new VoltageAudioJack( "Audio Input", "Audio Input", this, JackType.JackType_AudioInput );
   AddComponent( inputAudio );
   inputAudio.SetWantsMouseNotifications( false );
   inputAudio.SetPosition( 25, 49 );
   inputAudio.SetSize( 25, 25 );
   inputAudio.SetSkin( "Jack Round Teal Ring" );

   knobCentreFreq = new VoltageKnob( "Centre Frequency", "Centre Frequency", this, -1.0, 1.0, 0 );
   AddComponent( knobCentreFreq );
   knobCentreFreq.SetWantsMouseNotifications( false );
   knobCentreFreq.SetPosition( 24, 97 );
   knobCentreFreq.SetSize( 27, 27 );
   knobCentreFreq.SetSkin( "Plastic Red" );
   knobCentreFreq.SetRange( -1.0, 1.0, 0, false, 0 );
   knobCentreFreq.SetKnobParams( 215, 145 );
   knobCentreFreq.DisplayValueInPercent( false );
   knobCentreFreq.SetKnobAdjustsRing( true );

   knobFeedback = new VoltageKnob( "Feedback", "Feedback", this, -1, 1.0, 0 );
   AddComponent( knobFeedback );
   knobFeedback.SetWantsMouseNotifications( false );
   knobFeedback.SetPosition( 86, 93 );
   knobFeedback.SetSize( 37, 37 );
   knobFeedback.SetSkin( "Plastic Cherry" );
   knobFeedback.SetRingSkin( "Crescent White/Offblack" );
   knobFeedback.SetRange( -1, 1.0, 0, false, 0 );
   knobFeedback.SetKnobParams( 215, 145 );
   knobFeedback.DisplayValueInPercent( true );
   knobFeedback.SetKnobAdjustsRing( false );

   inputCV = new VoltageAudioJack( "CV Input", "CV Input", this, JackType.JackType_AudioInput );
   AddComponent( inputCV );
   inputCV.SetWantsMouseNotifications( false );
   inputCV.SetPosition( 25, 307 );
   inputCV.SetSize( 25, 25 );
   inputCV.SetSkin( "Jack Round Teal Ring" );

   knobCV = new VoltageKnob( "CV Depth", "CV Depth", this, -1.0, 1.0, 0 );
   AddComponent( knobCV );
   knobCV.SetWantsMouseNotifications( false );
   knobCV.SetPosition( 86, 302 );
   knobCV.SetSize( 37, 37 );
   knobCV.SetSkin( "Plastic Red" );
   knobCV.SetRingSkin( "Crescent White/Offblack" );
   knobCV.SetRange( -1.0, 1.0, 0, false, 0 );
   knobCV.SetKnobParams( 215, 145 );
   knobCV.DisplayValueInPercent( true );
   knobCV.SetKnobAdjustsRing( false );

   knobOutMix = new VoltageKnob( "Output Mix", "Output Mix", this, 0, 1.0, 0.5 );
   AddComponent( knobOutMix );
   knobOutMix.SetWantsMouseNotifications( false );
   knobOutMix.SetPosition( 86, 150 );
   knobOutMix.SetSize( 37, 37 );
   knobOutMix.SetSkin( "Plastic Orange" );
   knobOutMix.SetRingSkin( "Crescent White/Offblack" );
   knobOutMix.SetRange( 0, 1.0, 0.5, true, 0 );
   knobOutMix.SetKnobParams( 215, 145 );
   knobOutMix.DisplayValueInPercent( true );
   knobOutMix.SetKnobAdjustsRing( false );

   switchStages = new VoltageSwitch( "Phase Stages", "Phase Stages", this, 2 );
   AddComponent( switchStages );
   switchStages.SetWantsMouseNotifications( false );
   switchStages.SetPosition( 30, 153 );
   switchStages.SetSize( 15, 51 );
   switchStages.SetSkin( "4-State Slide Vertical" );

   outputAudio = new VoltageAudioJack( "Audio Output", "Audio Output", this, JackType.JackType_AudioOutput );
   AddComponent( outputAudio );
   outputAudio.SetWantsMouseNotifications( false );
   outputAudio.SetPosition( 93, 49 );
   outputAudio.SetSize( 25, 25 );
   outputAudio.SetSkin( "Jack Round Teal Ring" );

   switchPolarity = new VoltageSwitch( "Polarity", "Polarity", this, 0 );
   AddComponent( switchPolarity );
   switchPolarity.SetWantsMouseNotifications( false );
   switchPolarity.SetPosition( 91, 188 );
   switchPolarity.SetSize( 25, 25 );
   switchPolarity.SetSkin( "2-State Bar Horizontal" );

   textLabel1 = new VoltageLabel( "textLabel1", "textLabel1", this, "Input" );
   AddComponent( textLabel1 );
   textLabel1.SetWantsMouseNotifications( false );
   textLabel1.SetPosition( 12, 29 );
   textLabel1.SetSize( 50, 22 );
   textLabel1.SetEditable( false, false );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel1.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel1.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel1.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel1.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel1.SetBorderSize( 1 );
   textLabel1.SetMultiLineEdit( false );
   textLabel1.SetIsNumberEditor( false );
   textLabel1.SetNumberEditorRange( 0, 100 );
   textLabel1.SetNumberEditorInterval( 1 );
   textLabel1.SetNumberEditorUsesMouseWheel( false );
   textLabel1.SetHasCustomTextHoverColor( false );
   textLabel1.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel1.SetFont( "Verdana", 12, false, false );

   textLabel2 = new VoltageLabel( "textLabel2", "textLabel2", this, "Output" );
   AddComponent( textLabel2 );
   textLabel2.SetWantsMouseNotifications( false );
   textLabel2.SetPosition( 80, 29 );
   textLabel2.SetSize( 50, 22 );
   textLabel2.SetEditable( false, false );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel2.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel2.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel2.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel2.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel2.SetBorderSize( 1 );
   textLabel2.SetMultiLineEdit( false );
   textLabel2.SetIsNumberEditor( false );
   textLabel2.SetNumberEditorRange( 0, 100 );
   textLabel2.SetNumberEditorInterval( 1 );
   textLabel2.SetNumberEditorUsesMouseWheel( false );
   textLabel2.SetHasCustomTextHoverColor( false );
   textLabel2.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel2.SetFont( "Verdana", 12, false, false );

   textLabel3 = new VoltageLabel( "textLabel3", "textLabel3", this, "Freq" );
   AddComponent( textLabel3 );
   textLabel3.SetWantsMouseNotifications( false );
   textLabel3.SetPosition( 20, 75 );
   textLabel3.SetSize( 33, 22 );
   textLabel3.SetEditable( false, false );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel3.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel3.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel3.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel3.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel3.SetBorderSize( 1 );
   textLabel3.SetMultiLineEdit( false );
   textLabel3.SetIsNumberEditor( false );
   textLabel3.SetNumberEditorRange( 0, 100 );
   textLabel3.SetNumberEditorInterval( 1 );
   textLabel3.SetNumberEditorUsesMouseWheel( false );
   textLabel3.SetHasCustomTextHoverColor( false );
   textLabel3.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel3.SetFont( "Verdana", 12, false, false );

   textLabel4 = new VoltageLabel( "textLabel4", "textLabel4", this, "Feedback" );
   AddComponent( textLabel4 );
   textLabel4.SetWantsMouseNotifications( false );
   textLabel4.SetPosition( 80, 75 );
   textLabel4.SetSize( 50, 22 );
   textLabel4.SetEditable( false, false );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel4.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel4.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel4.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel4.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel4.SetBorderSize( 1 );
   textLabel4.SetMultiLineEdit( false );
   textLabel4.SetIsNumberEditor( false );
   textLabel4.SetNumberEditorRange( 0, 100 );
   textLabel4.SetNumberEditorInterval( 1 );
   textLabel4.SetNumberEditorUsesMouseWheel( false );
   textLabel4.SetHasCustomTextHoverColor( false );
   textLabel4.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel4.SetFont( "Verdana", 12, false, false );

   textLabel5 = new VoltageLabel( "textLabel5", "textLabel5", this, "CV Input" );
   AddComponent( textLabel5 );
   textLabel5.SetWantsMouseNotifications( false );
   textLabel5.SetPosition( 9, 284 );
   textLabel5.SetSize( 57, 22 );
   textLabel5.SetEditable( false, false );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel5.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel5.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel5.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel5.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel5.SetBorderSize( 1 );
   textLabel5.SetMultiLineEdit( false );
   textLabel5.SetIsNumberEditor( false );
   textLabel5.SetNumberEditorRange( 0, 100 );
   textLabel5.SetNumberEditorInterval( 1 );
   textLabel5.SetNumberEditorUsesMouseWheel( false );
   textLabel5.SetHasCustomTextHoverColor( false );
   textLabel5.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel5.SetFont( "Verdana", 12, false, false );

   textLabel6 = new VoltageLabel( "textLabel6", "textLabel6", this, "CV Depth" );
   AddComponent( textLabel6 );
   textLabel6.SetWantsMouseNotifications( false );
   textLabel6.SetPosition( 74, 284 );
   textLabel6.SetSize( 60, 22 );
   textLabel6.SetEditable( false, false );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel6.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel6.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel6.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel6.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel6.SetBorderSize( 1 );
   textLabel6.SetMultiLineEdit( false );
   textLabel6.SetIsNumberEditor( false );
   textLabel6.SetNumberEditorRange( 0, 100 );
   textLabel6.SetNumberEditorInterval( 1 );
   textLabel6.SetNumberEditorUsesMouseWheel( false );
   textLabel6.SetHasCustomTextHoverColor( false );
   textLabel6.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel6.SetFont( "Verdana", 12, false, false );

   textLabel7 = new VoltageLabel( "textLabel7", "textLabel7", this, "Stages" );
   AddComponent( textLabel7 );
   textLabel7.SetWantsMouseNotifications( false );
   textLabel7.SetPosition( 12, 133 );
   textLabel7.SetSize( 53, 22 );
   textLabel7.SetEditable( false, false );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel7.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel7.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel7.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel7.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel7.SetBorderSize( 1 );
   textLabel7.SetMultiLineEdit( false );
   textLabel7.SetIsNumberEditor( false );
   textLabel7.SetNumberEditorRange( 0, 100 );
   textLabel7.SetNumberEditorInterval( 1 );
   textLabel7.SetNumberEditorUsesMouseWheel( false );
   textLabel7.SetHasCustomTextHoverColor( false );
   textLabel7.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel7.SetFont( "Verdana", 12, false, false );

   textLabel8 = new VoltageLabel( "textLabel8", "textLabel8", this, "2" );
   AddComponent( textLabel8 );
   textLabel8.SetWantsMouseNotifications( false );
   textLabel8.SetPosition( 45, 190 );
   textLabel8.SetSize( 13, 13 );
   textLabel8.SetEditable( false, false );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel8.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel8.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel8.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel8.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel8.SetBorderSize( 1 );
   textLabel8.SetMultiLineEdit( false );
   textLabel8.SetIsNumberEditor( false );
   textLabel8.SetNumberEditorRange( 0, 100 );
   textLabel8.SetNumberEditorInterval( 1 );
   textLabel8.SetNumberEditorUsesMouseWheel( false );
   textLabel8.SetHasCustomTextHoverColor( false );
   textLabel8.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel8.SetFont( "Verdana", 12, false, false );

   textLabel9 = new VoltageLabel( "textLabel9", "textLabel9", this, "3" );
   AddComponent( textLabel9 );
   textLabel9.SetWantsMouseNotifications( false );
   textLabel9.SetPosition( 45, 178 );
   textLabel9.SetSize( 13, 13 );
   textLabel9.SetEditable( false, false );
   textLabel9.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel9.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel9.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel9.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel9.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel9.SetBorderSize( 1 );
   textLabel9.SetMultiLineEdit( false );
   textLabel9.SetIsNumberEditor( false );
   textLabel9.SetNumberEditorRange( 0, 100 );
   textLabel9.SetNumberEditorInterval( 1 );
   textLabel9.SetNumberEditorUsesMouseWheel( false );
   textLabel9.SetHasCustomTextHoverColor( false );
   textLabel9.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel9.SetFont( "Verdana", 12, false, false );

   textLabel10 = new VoltageLabel( "textLabel10", "textLabel10", this, "4" );
   AddComponent( textLabel10 );
   textLabel10.SetWantsMouseNotifications( false );
   textLabel10.SetPosition( 45, 166 );
   textLabel10.SetSize( 13, 13 );
   textLabel10.SetEditable( false, false );
   textLabel10.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel10.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel10.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel10.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel10.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel10.SetBorderSize( 1 );
   textLabel10.SetMultiLineEdit( false );
   textLabel10.SetIsNumberEditor( false );
   textLabel10.SetNumberEditorRange( 0, 100 );
   textLabel10.SetNumberEditorInterval( 1 );
   textLabel10.SetNumberEditorUsesMouseWheel( false );
   textLabel10.SetHasCustomTextHoverColor( false );
   textLabel10.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel10.SetFont( "Verdana", 12, false, false );

   textLabel11 = new VoltageLabel( "textLabel11", "textLabel11", this, "5" );
   AddComponent( textLabel11 );
   textLabel11.SetWantsMouseNotifications( false );
   textLabel11.SetPosition( 45, 154 );
   textLabel11.SetSize( 13, 13 );
   textLabel11.SetEditable( false, false );
   textLabel11.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel11.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel11.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel11.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel11.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel11.SetBorderSize( 1 );
   textLabel11.SetMultiLineEdit( false );
   textLabel11.SetIsNumberEditor( false );
   textLabel11.SetNumberEditorRange( 0, 100 );
   textLabel11.SetNumberEditorInterval( 1 );
   textLabel11.SetNumberEditorUsesMouseWheel( false );
   textLabel11.SetHasCustomTextHoverColor( false );
   textLabel11.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel11.SetFont( "Verdana", 12, false, false );

   textLabel12 = new VoltageLabel( "textLabel12", "textLabel12", this, "Out Mix" );
   AddComponent( textLabel12 );
   textLabel12.SetWantsMouseNotifications( false );
   textLabel12.SetPosition( 70, 133 );
   textLabel12.SetSize( 65, 22 );
   textLabel12.SetEditable( false, false );
   textLabel12.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel12.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel12.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel12.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel12.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel12.SetBorderSize( 1 );
   textLabel12.SetMultiLineEdit( false );
   textLabel12.SetIsNumberEditor( false );
   textLabel12.SetNumberEditorRange( 0, 100 );
   textLabel12.SetNumberEditorInterval( 1 );
   textLabel12.SetNumberEditorUsesMouseWheel( false );
   textLabel12.SetHasCustomTextHoverColor( false );
   textLabel12.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel12.SetFont( "Verdana", 12, false, false );

   textLabel13 = new VoltageLabel( "textLabel13", "textLabel13", this, "Norm" );
   AddComponent( textLabel13 );
   textLabel13.SetWantsMouseNotifications( false );
   textLabel13.SetPosition( 67, 191 );
   textLabel13.SetSize( 27, 18 );
   textLabel13.SetEditable( false, false );
   textLabel13.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel13.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel13.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel13.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel13.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel13.SetBorderSize( 1 );
   textLabel13.SetMultiLineEdit( false );
   textLabel13.SetIsNumberEditor( false );
   textLabel13.SetNumberEditorRange( 0, 100 );
   textLabel13.SetNumberEditorInterval( 1 );
   textLabel13.SetNumberEditorUsesMouseWheel( false );
   textLabel13.SetHasCustomTextHoverColor( false );
   textLabel13.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel13.SetFont( "Verdana", 10, false, false );

   textLabel14 = new VoltageLabel( "textLabel14", "textLabel14", this, "Inv" );
   AddComponent( textLabel14 );
   textLabel14.SetWantsMouseNotifications( false );
   textLabel14.SetPosition( 116, 191 );
   textLabel14.SetSize( 28, 18 );
   textLabel14.SetEditable( false, false );
   textLabel14.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel14.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel14.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel14.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel14.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel14.SetBorderSize( 1 );
   textLabel14.SetMultiLineEdit( false );
   textLabel14.SetIsNumberEditor( false );
   textLabel14.SetNumberEditorRange( 0, 100 );
   textLabel14.SetNumberEditorInterval( 1 );
   textLabel14.SetNumberEditorUsesMouseWheel( false );
   textLabel14.SetHasCustomTextHoverColor( false );
   textLabel14.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel14.SetFont( "Verdana", 10, false, false );

   textLabel15 = new VoltageLabel( "textLabel15", "textLabel15", this, "Fifth Dimension Phaser Factory" );
   AddComponent( textLabel15 );
   textLabel15.SetWantsMouseNotifications( false );
   textLabel15.SetPosition( 9, 1 );
   textLabel15.SetSize( 127, 33 );
   textLabel15.SetEditable( false, false );
   textLabel15.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel15.SetJustificationFlags( VoltageLabel.Justification.Top );
   textLabel15.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel15.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel15.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel15.SetBorderSize( 1 );
   textLabel15.SetMultiLineEdit( true );
   textLabel15.SetIsNumberEditor( false );
   textLabel15.SetNumberEditorRange( 0, 100 );
   textLabel15.SetNumberEditorInterval( 1 );
   textLabel15.SetNumberEditorUsesMouseWheel( false );
   textLabel15.SetHasCustomTextHoverColor( false );
   textLabel15.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel15.SetFont( "Verdana", 14, true, false );

   textLabel16 = new VoltageLabel( "textLabel16", "textLabel16", this, "Dome Music Technologies" );
   AddComponent( textLabel16 );
   textLabel16.SetWantsMouseNotifications( false );
   textLabel16.SetPosition( 14, 342 );
   textLabel16.SetSize( 116, 18 );
   textLabel16.SetEditable( false, false );
   textLabel16.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel16.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel16.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel16.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel16.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel16.SetBorderSize( 1 );
   textLabel16.SetMultiLineEdit( false );
   textLabel16.SetIsNumberEditor( false );
   textLabel16.SetNumberEditorRange( 0, 100 );
   textLabel16.SetNumberEditorInterval( 1 );
   textLabel16.SetNumberEditorUsesMouseWheel( false );
   textLabel16.SetHasCustomTextHoverColor( false );
   textLabel16.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel16.SetFont( "Verdana", 10, false, false );

   textLabel17 = new VoltageLabel( "textLabel17", "textLabel17", this, "Dry" );
   AddComponent( textLabel17 );
   textLabel17.SetWantsMouseNotifications( false );
   textLabel17.SetPosition( 83, 174 );
   textLabel17.SetSize( 22, 17 );
   textLabel17.SetEditable( false, false );
   textLabel17.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel17.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel17.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel17.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel17.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel17.SetBorderSize( 1 );
   textLabel17.SetMultiLineEdit( false );
   textLabel17.SetIsNumberEditor( false );
   textLabel17.SetNumberEditorRange( 0, 100 );
   textLabel17.SetNumberEditorInterval( 1 );
   textLabel17.SetNumberEditorUsesMouseWheel( false );
   textLabel17.SetHasCustomTextHoverColor( false );
   textLabel17.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel17.SetFont( "Verdana", 8, false, false );

   textLabel18 = new VoltageLabel( "textLabel18", "textLabel18", this, "Wet" );
   AddComponent( textLabel18 );
   textLabel18.SetWantsMouseNotifications( false );
   textLabel18.SetPosition( 111, 174 );
   textLabel18.SetSize( 22, 17 );
   textLabel18.SetEditable( false, false );
   textLabel18.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel18.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel18.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel18.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel18.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel18.SetBorderSize( 1 );
   textLabel18.SetMultiLineEdit( false );
   textLabel18.SetIsNumberEditor( false );
   textLabel18.SetNumberEditorRange( 0, 100 );
   textLabel18.SetNumberEditorInterval( 1 );
   textLabel18.SetNumberEditorUsesMouseWheel( false );
   textLabel18.SetHasCustomTextHoverColor( false );
   textLabel18.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel18.SetFont( "Verdana", 8, false, false );

   textLabel19 = new VoltageLabel( "textLabel19", "textLabel19", this, "-ve" );
   AddComponent( textLabel19 );
   textLabel19.SetWantsMouseNotifications( false );
   textLabel19.SetPosition( 86, 328 );
   textLabel19.SetSize( 22, 17 );
   textLabel19.SetEditable( false, false );
   textLabel19.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel19.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel19.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel19.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel19.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel19.SetBorderSize( 1 );
   textLabel19.SetMultiLineEdit( false );
   textLabel19.SetIsNumberEditor( false );
   textLabel19.SetNumberEditorRange( 0, 100 );
   textLabel19.SetNumberEditorInterval( 1 );
   textLabel19.SetNumberEditorUsesMouseWheel( false );
   textLabel19.SetHasCustomTextHoverColor( false );
   textLabel19.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel19.SetFont( "Verdana", 8, false, false );

   textLabel20 = new VoltageLabel( "textLabel20", "textLabel20", this, "+ve" );
   AddComponent( textLabel20 );
   textLabel20.SetWantsMouseNotifications( false );
   textLabel20.SetPosition( 108, 328 );
   textLabel20.SetSize( 22, 17 );
   textLabel20.SetEditable( false, false );
   textLabel20.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel20.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel20.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel20.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel20.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel20.SetBorderSize( 1 );
   textLabel20.SetMultiLineEdit( false );
   textLabel20.SetIsNumberEditor( false );
   textLabel20.SetNumberEditorRange( 0, 100 );
   textLabel20.SetNumberEditorInterval( 1 );
   textLabel20.SetNumberEditorUsesMouseWheel( false );
   textLabel20.SetHasCustomTextHoverColor( false );
   textLabel20.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel20.SetFont( "Verdana", 8, false, false );

   textLabel21 = new VoltageLabel( "textLabel21", "textLabel21", this, "-ve" );
   AddComponent( textLabel21 );
   textLabel21.SetWantsMouseNotifications( false );
   textLabel21.SetPosition( 86, 118 );
   textLabel21.SetSize( 22, 17 );
   textLabel21.SetEditable( false, false );
   textLabel21.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel21.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel21.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel21.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel21.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel21.SetBorderSize( 1 );
   textLabel21.SetMultiLineEdit( false );
   textLabel21.SetIsNumberEditor( false );
   textLabel21.SetNumberEditorRange( 0, 100 );
   textLabel21.SetNumberEditorInterval( 1 );
   textLabel21.SetNumberEditorUsesMouseWheel( false );
   textLabel21.SetHasCustomTextHoverColor( false );
   textLabel21.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel21.SetFont( "Verdana", 8, false, false );

   textLabel22 = new VoltageLabel( "textLabel22", "textLabel22", this, "+ve" );
   AddComponent( textLabel22 );
   textLabel22.SetWantsMouseNotifications( false );
   textLabel22.SetPosition( 108, 118 );
   textLabel22.SetSize( 22, 17 );
   textLabel22.SetEditable( false, false );
   textLabel22.SetJustificationFlags( VoltageLabel.Justification.Left );
   textLabel22.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel22.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel22.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel22.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel22.SetBorderSize( 1 );
   textLabel22.SetMultiLineEdit( false );
   textLabel22.SetIsNumberEditor( false );
   textLabel22.SetNumberEditorRange( 0, 100 );
   textLabel22.SetNumberEditorInterval( 1 );
   textLabel22.SetNumberEditorUsesMouseWheel( false );
   textLabel22.SetHasCustomTextHoverColor( false );
   textLabel22.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel22.SetFont( "Verdana", 8, false, false );

   knobLFORate = new VoltageKnob( "LFO Rate", "LFO Rate", this, 0.04, 12, 1 );
   AddComponent( knobLFORate );
   knobLFORate.SetWantsMouseNotifications( false );
   knobLFORate.SetPosition( 90, 255 );
   knobLFORate.SetSize( 27, 27 );
   knobLFORate.SetSkin( "Plastic Red" );
   knobLFORate.SetRange( 0.04, 12, 1, false, 0 );
   knobLFORate.SetKnobParams( 215, 145 );
   knobLFORate.DisplayValueInPercent( false );
   knobLFORate.SetKnobAdjustsRing( true );
   knobLFORate.SetMidpointValue( 1 );

   textLabel23 = new VoltageLabel( "textLabel23", "textLabel23", this, "LFO Rate" );
   AddComponent( textLabel23 );
   textLabel23.SetWantsMouseNotifications( false );
   textLabel23.SetPosition( 74, 235 );
   textLabel23.SetSize( 60, 22 );
   textLabel23.SetEditable( false, false );
   textLabel23.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel23.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel23.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel23.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel23.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel23.SetBorderSize( 1 );
   textLabel23.SetMultiLineEdit( false );
   textLabel23.SetIsNumberEditor( false );
   textLabel23.SetNumberEditorRange( 0, 100 );
   textLabel23.SetNumberEditorInterval( 1 );
   textLabel23.SetNumberEditorUsesMouseWheel( false );
   textLabel23.SetHasCustomTextHoverColor( false );
   textLabel23.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel23.SetFont( "Verdana", 12, false, false );

   switchCircuit = new VoltageSwitch( "Circuit Topology", "Circuit Topology", this, 0 );
   AddComponent( switchCircuit );
   switchCircuit.SetWantsMouseNotifications( false );
   switchCircuit.SetPosition( 58, 217 );
   switchCircuit.SetSize( 27, 15 );
   switchCircuit.SetSkin( "2-State Slide Bright Horizontal" );

   textLabel24 = new VoltageLabel( "textLabel24", "textLabel24", this, "Circuit 1" );
   AddComponent( textLabel24 );
   textLabel24.SetWantsMouseNotifications( false );
   textLabel24.SetPosition( 7, 214 );
   textLabel24.SetSize( 53, 20 );
   textLabel24.SetEditable( false, false );
   textLabel24.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel24.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel24.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel24.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel24.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel24.SetBorderSize( 1 );
   textLabel24.SetMultiLineEdit( false );
   textLabel24.SetIsNumberEditor( false );
   textLabel24.SetNumberEditorRange( 0, 100 );
   textLabel24.SetNumberEditorInterval( 1 );
   textLabel24.SetNumberEditorUsesMouseWheel( false );
   textLabel24.SetHasCustomTextHoverColor( false );
   textLabel24.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel24.SetFont( "Verdana", 12, false, false );

   textLabel25 = new VoltageLabel( "textLabel25", "textLabel25", this, "Circuit 2" );
   AddComponent( textLabel25 );
   textLabel25.SetWantsMouseNotifications( false );
   textLabel25.SetPosition( 82, 214 );
   textLabel25.SetSize( 53, 20 );
   textLabel25.SetEditable( false, false );
   textLabel25.SetJustificationFlags( VoltageLabel.Justification.HorizCentered );
   textLabel25.SetJustificationFlags( VoltageLabel.Justification.VertCentered );
   textLabel25.SetColor( new Color( 119, 0, 0, 255 ) );
   textLabel25.SetBkColor( new Color( 65, 65, 65, 0 ) );
   textLabel25.SetBorderColor( new Color( 0, 0, 0, 0 ) );
   textLabel25.SetBorderSize( 1 );
   textLabel25.SetMultiLineEdit( false );
   textLabel25.SetIsNumberEditor( false );
   textLabel25.SetNumberEditorRange( 0, 100 );
   textLabel25.SetNumberEditorInterval( 1 );
   textLabel25.SetNumberEditorUsesMouseWheel( false );
   textLabel25.SetHasCustomTextHoverColor( false );
   textLabel25.SetTextHoverColor( new Color( 0, 0, 0, 255 ) );
   textLabel25.SetFont( "Verdana", 12, false, false );
}



//-------------------------------------------------------------------------------
//  public void Initialize()

//  Initialize will get called shortly after your module's constructor runs. You can use it to
//  do any initialization that the auto-generated code doesn't handle.
//-------------------------------------------------------------------------------
@Override
public void Initialize()
{
   //[user-Initialize]   Add your own initialization code here

   CheckStages();
   CheckPolarity();
   CheckCircuit(switchCircuit.GetValue());
   CheckConnections();
   SetLFORate();
   
   smoothFreq.SetValue(knobCentreFreq.GetValue());
   smoothFeedback.SetValue(knobFeedback.GetValue());
   smoothMix.SetValue(knobOutMix.GetValue());
   smoothDepth.SetValue(knobCV.GetValue());
   
   previousFeedback = 0.0;
   
   stage1Capacitor = 0.0;
   stage2Capacitor = 0.0;
   stage3Capacitor = 0.0;
   stage4Capacitor = 0.0;
   stage5Capacitor = 0.0;

   //[/user-Initialize]
}


//-------------------------------------------------------------------------------
//  public void Destroy()

//  Destroy will get called just before your module gets deleted. You can use it to perform any
//  cleanup that's not handled automatically by Java.
//-------------------------------------------------------------------------------
@Override
public void Destroy()
{
   super.Destroy();
   //[user-Destroy]   Add your own module-getting-deleted code here



   //[/user-Destroy]
}


//-------------------------------------------------------------------------------
//  public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )

//  Notify will get called when various events occur - control values changing, timers firing, etc.
//-------------------------------------------------------------------------------
@Override
public boolean Notify( VoltageComponent component, ModuleNotifications notification, double doubleValue, long longValue, int x, int y, Object object )
{
   //[user-Notify]   Add your own notification handling code between this line and the notify-close comment
   switch( notification )
   {
      case Knob_Changed:   // doubleValue is the new VoltageKnob value
      {
         if (component == knobLFORate)
         {
            SetLFORate();
         }
         else if (component == knobCentreFreq)
         {
            smoothFreq.SetValue(doubleValue);
         }
         else if (component == knobFeedback)
         {
             smoothFeedback.SetValue(doubleValue);
         }
         else if (component == knobOutMix)
         {
            smoothMix.SetValue(doubleValue);
         }
         else if (component == knobCV)
         {
            smoothDepth.SetValue(doubleValue);
         }
         
      }
      break;
   
      case Slider_Changed:   // doubleValue is the new slider value
      {
      }
      break;
   
      case Button_Changed:   // doubleValue is the new button/toggle button value
      {
      }
      break;
   
      case Switch_Changed:   // doubleValue is the new switch value
      {
         if (component == switchStages)
         {
            CheckStages();
         }
         else if (component == switchPolarity)
         {
            CheckPolarity();
         }
         else if (component == switchCircuit)
         {
            CheckCircuit(doubleValue);
         }
      }
      break;
   
      case Jack_Connected:   // longValue is the new cable ID
      {
         CheckConnections();
      }
      break;
   
      case Jack_Disconnected:   // All cables have been disconnected from this jack
      {
         CheckConnections();
      }
      break;
   
      case GUI_Update_Timer:   // Called every 50ms (by default) if turned on
      {
      }
      break;
   
      case Object_MouseMove:   // called when mouse is over an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_MouseLeave:  // called when mouse leaves an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonDown:   // called when user left-clicks on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_LeftButtonUp:   // called when user releases left mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonDown:   // called when user releases right mouse button on an object that receives mouse notifications. 'object' parameter is a VoltageMouseKeyFlags object.
      {
      }
      break;
   
      case Object_RightButtonUp:   // called when user right-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      case Object_LeftButtonDoubleClick: // called when user left-button double-clicks on an object that receives mouse notifications
      {
      }
      break;
   
      // Less common notifications:
   
      case Named_Timer:   // object contains a String with the name of the timer that has fired
      {
      }
      break;
   
      case Canvas_Painting:   // About to paint canvas.  object is a java.awt.Rectangle with painting boundaries
      {
      }
      break;
   
      case Canvas_Painted:   // Canvas painting is complete
      {
      }
      break;
   
      case Control_DragStart:    // A user has started dragging on a control that has been marked as draggable
      {
      }
      break;
   
      case Control_DragOn:       // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragOff:      // This control has been dragged over during a drag operation. object contains the dragged object
      {
      }
      break;
   
      case Control_DragEnd:      // A user has ended their drag on a control that has been marked as draggable
      {
      }
      break;
   
      case Label_Changed:        // The text of an editable text control has changed
      {
      }
      break;
   
      case SoundPlayback_Start:   // A sound has begun playback
      {
      }
      break;
   
      case SoundPlayback_End:     // A sound has ended playback
      {
      }
      break;
   
      case Scrollbar_Position:    // longValue is the new scrollbar position
      {
      }
      break;
   
      case PolyVoices_Changed:    // longValue is the new number of poly voices
      {
      }
      break;
   
      case File_Dropped:     // 'object' is a String containing the file path
      {
      }
      break;
   
      case Preset_Loading_Start:   // called when preset loading begins
      {
      }
      break;
   
      case Preset_Loading_Finish:  // called when preset loading finishes
      {
      }
      break;
   
      case Variation_Loading_Start:    // sent when a variation is about to load
      {
      }
      break;
   
      case Variation_Loading_Finish:   // sent when a variation has just finished loading
      {
      }
      break;
   
      case Tempo_Changed:     // doubleValue is the new tempo
      {
      }
      break;
   
      case Randomized:     // called when the module's controls get randomized
      {
      }
      break;
   
      case VariationListChanged:   // sent when a variation gets added, deleted, or renamed, or the variations list gets reordered
      {
      }
      break;
   
      case Key_Press:     // sent when module has keyboard focus and a key is pressed; object is a VoltageKeyPressInfo object
      {
      }
      break;
   
      case Reset:    // sent when the module has been reset to default settings
      {
      }
      break;
   
      case Keyboard_NoteOn:   // sent when a note has been pressed on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Keyboard_NoteOff:   // sent when a note has been released on a VoltageKeyboard object. longValue is the note value ( 0-127 )
      {
      }
      break;
   
      case Curve_Changed:   // sent when user has edited a curve's value. 'object' will be a VoltageCurve.CurveChangeNotification object.
      {
      }
      break;
   }



   return false;
   //[/user-Notify]
}


//-------------------------------------------------------------------------------
//  public void ProcessSample()

//  ProcessSample is called once per sample. Usually it's where you read
//  from input jacks, process audio, and write it to your output jacks.
//  Since ProcesssSample gets called 48,000 times per second, offload CPU-intensive operations
//  to other threads when possible and avoid calling native functions.
//-------------------------------------------------------------------------------
@Override
public void ProcessSample()
{
   //[user-ProcessSample]   Add your own process-sampling code here
   double sumOfAllCVs;
   double drySignal;
   double wetSignal;
   double timeFactorRC;
   double resistorVoltage;
   double attenuatedCV;
   double voltsPerOctaveMultiplier;
   double finalOutputValue;
   double smoothedFreq;
   double smoothedFeedback;
   double smoothedMix;
   double smoothedDepth;
   
   drySignal = inputAudio.GetValue();
   
   smoothedFreq = smoothFreq.GetSmoothValue();
   smoothedFeedback = smoothFeedback.GetSmoothValue();
   smoothedMix = smoothMix.GetSmoothValue();
   smoothedDepth = smoothDepth.GetSmoothValue();
   
   wetSignal = drySignal + (previousFeedback * smoothedFeedback);
   
   if (CVinConnected)
   {
      attenuatedCV = inputCV.GetValue() * smoothedDepth;
   }
   else
   {
      TriangleLFO.AdvanceSample();
      attenuatedCV = TriangleLFO.GetTriangleValue() * smoothedDepth;
   }
   
   sumOfAllCVs = FREQ_RANGE_OCTAVES * smoothedFreq;
   sumOfAllCVs += attenuatedCV;
   
   voltsPerOctaveMultiplier = Values.FastTwoToTheX((float)sumOfAllCVs);
   
   timeFactorRC = Values.FastEToTheX ((float)(CENTRE_FREQ * voltsPerOctaveMultiplier));
   
   if (OriginalCircuit)
   {
      // Original Fifth Dimension Algorithm
      
      // Perform Stage 1 Allpass unconditionally
      resistorVoltage = wetSignal - stage1Capacitor;
      stage1Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
      wetSignal = stage1Capacitor + stage1Capacitor - wetSignal;
   
      // Perform Stage 2 Allpass unconditionally
      resistorVoltage = wetSignal - stage2Capacitor;
      stage2Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
      wetSignal = stage2Capacitor + stage2Capacitor - wetSignal;
   
      if (numberOfStages > 2)
      {
         // Perform Stage 3 Allpass
         resistorVoltage = wetSignal - stage3Capacitor;
         stage3Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
         wetSignal = stage3Capacitor + stage3Capacitor - wetSignal;
      }
   
      if (numberOfStages > 3)
      {
         // Perform Stage 4 Allpass
         resistorVoltage = wetSignal - stage4Capacitor;
         stage4Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
         wetSignal = stage4Capacitor + stage4Capacitor - wetSignal;
      }
   
      if (numberOfStages > 4)
      {
         // Perform Stage 5 Allpass
         resistorVoltage = wetSignal - stage5Capacitor;
         stage5Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
         wetSignal = stage5Capacitor + stage5Capacitor - wetSignal;
      }
   
      // Assign wet signal as feedback value for next iteration
      previousFeedback = wetSignal;
   
      // Now perform output mixing
      if (invertOutput)
      {
         wetSignal = -wetSignal;
      }
   
      finalOutputValue = (smoothedMix * wetSignal) +
                         ((1.0 - smoothedMix) * drySignal);
                      
   }
   else
   {
      // Circuit 2, more traditional topology
      // Perform Stage 1 Allpass unconditionally
      resistorVoltage = wetSignal - stage1Capacitor;
      stage1Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
      wetSignal = stage1Capacitor - resistorVoltage;
   
      // Perform Stage 2 Allpass unconditionally
      resistorVoltage = wetSignal - stage2Capacitor;
      stage2Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
      wetSignal = stage2Capacitor - resistorVoltage;
   
      if (numberOfStages > 2)
      {
         // Perform Stage 3 Allpass
         resistorVoltage = wetSignal - stage3Capacitor;
         stage3Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
         wetSignal = stage3Capacitor - resistorVoltage;
      }
   
      if (numberOfStages > 3)
      {
         // Perform Stage 4 Allpass
         resistorVoltage = wetSignal - stage4Capacitor;
         stage4Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
         wetSignal = stage4Capacitor - resistorVoltage;
      }
   
      if (numberOfStages > 4)
      {
         // Perform Stage 5 Allpass
         resistorVoltage = wetSignal - stage5Capacitor;
         stage5Capacitor = wetSignal - (resistorVoltage * timeFactorRC);
         wetSignal = stage5Capacitor - resistorVoltage;
      }
   
      // Now perform output mixing
      if (invertOutput)
      {
         wetSignal = -wetSignal;
      }
   
      finalOutputValue = (wetSignal + drySignal) * 0.5;
      
      // Use mixed signal as feedback value for next iteration
      previousFeedback = finalOutputValue * 1.9;   // Boost to +/- 190% max
                      
   }
                      
   outputAudio.SetValue(finalOutputValue);
   //[/user-ProcessSample]
}


//-------------------------------------------------------------------------------
//  public void ProcessBypassedSample()

//  ProcessBypassedSample gets called instead of ProcessSample when you've checked the "Can Be Bypassed" box
//  and a user has bypassed your module. If your module processes data from input jacks and then sends it to
//  output jack(s), make ProcessBypassedSample just send the data from the input jacks to the output jacks without
//  processing it.
//-------------------------------------------------------------------------------
@Override
public void ProcessBypassedSample()
{
   //[user-ProcessBypassedSample]   Add your own code here

   double temp;
   
   temp = inputAudio.GetValue();
   outputAudio.SetValue(temp);

   //[/user-ProcessBypassedSample]
}


//-------------------------------------------------------------------------------
//  public String GetTooltipText( VoltageComponent component )

//  Gets called when a tooltip is about to display for a control. Override it if
//  you want to change what the tooltip displays - if you want a knob to work in logarithmic fashion,
//  for instance, you can translate the knob's current value to a log-based string and display it here.
//-------------------------------------------------------------------------------
@Override
public String GetTooltipText( VoltageComponent component )
{
   //[user-GetTooltipText]   Add your own code here



   return super.GetTooltipText( component );
   //[/user-GetTooltipText]
}


//-------------------------------------------------------------------------------
//  public void EditComponentValue( VoltageComponent component, double newValue, String newText )

//  Gets called after a user clicks on a tooltip and types in a new value for a control. Override this if
//  you've changed the default tooltip display (translating a linear value to logarithmic, for instance)
//  in GetTooltipText().
//-------------------------------------------------------------------------------
@Override
public void EditComponentValue( VoltageComponent component, double newValue, String newText )
{
   //[user-EditComponentValue]   Add your own code here



   //[/user-EditComponentValue]
   super.EditComponentValue( component, newValue, newText );
}


//-------------------------------------------------------------------------------
//  public void OnUndoRedo( String undoType, double newValue, Object optionalObject )

//  If you've created custom undo events via calls to CreateUndoEvent, you'll need to
//  process them in this function when they get triggered by undo/redo actions.
//-------------------------------------------------------------------------------
@Override
public void OnUndoRedo( String undoType, double newValue, Object optionalObject )
{
   //[user-OnUndoRedo]   Add your own code here



   //[/user-OnUndoRedo]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformation()

//  Gets called when the module's state gets saved, typically when the user saves a preset with
//  this module in it. Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformation()
{
   //[user-GetStateInformation]   Add your own code here



   return null;
   //[/user-GetStateInformation]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformation(byte[] stateInfo)

//  Gets called when this module's state is getting restored, typically when a user opens a preset with
//  this module in it. The stateInfo parameter will contain whatever custom data you stored in GetStateInformation().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformation(byte[] stateInfo)
{
   //[user-SetStateInformation]   Add your own code here



   //[/user-SetStateInformation]
}


//-------------------------------------------------------------------------------
//  public byte[] GetStateInformationForVariations()

//  Gets called when a user saves a variation with this module in it.
//  Voltage Modular will automatically save the states of knobs, sliders, etc.,
//  but if you have any custom state information you need to save, return it from this function.
//-------------------------------------------------------------------------------
@Override
public byte[] GetStateInformationForVariations()
{
   //[user-GetStateInformationForVariations]   Add your own code here



   return GetStateInformation();
   //[/user-GetStateInformationForVariations]
}


//-------------------------------------------------------------------------------
//  public void SetStateInformationForVariations(byte[] stateInfo)

//  Gets called when a user loads a variation with this module in it.
//  The stateInfo parameter will contain whatever custom data you stored in GetStateInformationForVariations().
//-------------------------------------------------------------------------------
@Override
public void SetStateInformationForVariations(byte[] stateInfo)
{
   //[user-SetStateInformationForVariations]   Add your own code here
   SetStateInformation(stateInfo);



   //[/user-SetStateInformationForVariations]
}


// Auto-generated variables
private VoltageLabel textLabel25;
private VoltageLabel textLabel24;
private VoltageSwitch switchCircuit;
private VoltageLabel textLabel23;
private VoltageKnob knobLFORate;
private VoltageLabel textLabel22;
private VoltageLabel textLabel21;
private VoltageLabel textLabel20;
private VoltageLabel textLabel19;
private VoltageLabel textLabel18;
private VoltageLabel textLabel17;
private VoltageLabel textLabel16;
private VoltageLabel textLabel15;
private VoltageLabel textLabel14;
private VoltageLabel textLabel13;
private VoltageLabel textLabel12;
private VoltageLabel textLabel11;
private VoltageLabel textLabel10;
private VoltageLabel textLabel9;
private VoltageLabel textLabel8;
private VoltageLabel textLabel7;
private VoltageLabel textLabel6;
private VoltageLabel textLabel5;
private VoltageLabel textLabel4;
private VoltageLabel textLabel3;
private VoltageLabel textLabel2;
private VoltageLabel textLabel1;
private VoltageSwitch switchPolarity;
private VoltageAudioJack outputAudio;
private VoltageSwitch switchStages;
private VoltageKnob knobOutMix;
private VoltageKnob knobCV;
private VoltageAudioJack inputCV;
private VoltageKnob knobFeedback;
private VoltageKnob knobCentreFreq;
private VoltageAudioJack inputAudio;


//[user-code-and-variables]    Add your own variables and functions here

// Constants

private final double CENTRE_FREQ = -4500.0 / Values.SampleRate;
private final double FREQ_RANGE_OCTAVES = 5.0;

// Variables

private double previousFeedback;
private int numberOfStages;
private boolean invertOutput;

private double stage1Capacitor;
private double stage2Capacitor;
private double stage3Capacitor;
private double stage4Capacitor;
private double stage5Capacitor;

private boolean CVinConnected;
private boolean InputConnected;
private boolean OutputConnected;
private boolean OriginalCircuit;

// Objects

protected DigitalOscillator TriangleLFO = new DigitalOscillator();

private SmoothValue smoothFreq = new SmoothValue();
private SmoothValue smoothFeedback = new SmoothValue();
private SmoothValue smoothMix = new SmoothValue();
private SmoothValue smoothDepth = new SmoothValue();


private void CheckConnections()
{
   CVinConnected = inputCV.IsConnected();
   InputConnected = inputAudio.IsConnected();
   OutputConnected = outputAudio.IsConnected();   
}

private void CheckStages ()
{
   double temp;
   
   temp = switchStages.GetValue();
   
   if (temp < 0.5)
   {
      numberOfStages = 2;
   }
   else if (temp < 1.5)
   {
      numberOfStages = 3;
   }
   else if (temp < 2.5)
   {
      numberOfStages = 4;
   }
   else
   {
      numberOfStages = 5;
   }

}

private void CheckPolarity ()
{
   invertOutput = (switchPolarity.GetValue() > 0.5);
}

private void CheckCircuit (double circuit)
{
   OriginalCircuit = (circuit < 0.5);
   knobOutMix.SetEnabled(OriginalCircuit);
}

private void SetLFORate()
{
   double temp;
   temp = knobLFORate.GetValue();
   TriangleLFO.SetFrequency(temp);
}



//[/user-code-and-variables]
}

 